package com.example.labstatus;

import android.content.res.ColorStateList;
import android.os.AsyncTask;
import android.os.Bundle;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Iterator;

public class DetailActivity extends AppCompatActivity {
    String cpu="CPU Utilization :";
    String core=""; //"Core 1: 100%\t\t\t\t\t\t\tCore 2: 100%\nCore 3: 100%\\t\\t\\t\\t\\t\\t\\tCore 4: 100%";
    String lab,pc;
    ProgressBar bar;
    String TAG="Datail Activity";
    TextView cpu_tv,core_tv;
    int counter=0;
    FloatingActionButton fab_lab,fab_keyboard,fab_mouse,fab_search,fab;
    boolean isFABOpen=false;
    Boolean isKeyboardConnected=false;
    Boolean isMouseConnected=false;

    final Handler handler = new Handler();
    HashMap<String,Double> status=new HashMap<>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detail);
        lab=getIntent().getStringExtra("lab");
        pc=getIntent().getStringExtra("pc");
        bar=findViewById(R.id.pBar_detail);
        bar.setVisibility(View.GONE);
        cpu_tv=findViewById(R.id.cpu_utilization);
        core_tv=findViewById(R.id.core);
        String lab_pc=lab+"-"+pc;
        setTitle(lab_pc);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);


        fab =  findViewById(R.id.fab_detail);
        fab_lab =  findViewById(R.id.fab_lab_detail);
        fab_keyboard =  findViewById(R.id.fab_keyboard_detail);
        fab_mouse =  findViewById(R.id.fab_mouse_detail);
        fab_search =  findViewById(R.id.fab_search_detail);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
              /*  Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();*/
                if(!isFABOpen){
                    showFABMenu();
                }else{
                    closeFABMenu();
                }
            }
        });



        handler.post(new Runnable() {
                                @Override
                                public void run() {
                                    //Do something after 20 seconds
                                    new GetDetails().execute();
                                    handler.postDelayed(this, 1000);
                                }
                            });
        new GetHardwareDetails().execute();

    }
    private void showFABMenu(){
        isFABOpen=true;
        fab.setImageResource(R.drawable.ic_fab_right);
        fab_lab.animate().translationX(-getResources().getDimension(R.dimen.standard_65));
        fab_search.animate().translationX(-getResources().getDimension(R.dimen.standard_115));
        fab_keyboard.animate().translationX(-getResources().getDimension(R.dimen.standard_165));
        fab_mouse.animate().translationX(-getResources().getDimension(R.dimen.standard_215));
    }

    private void closeFABMenu(){
        isFABOpen=false;
        fab.setImageResource(R.drawable.ic_fab_left);
        fab_lab.animate().translationX(0);
        fab_search.animate().translationX(0);
        fab_keyboard.animate().translationX(0);
        fab_mouse.animate().translationX(0);
    }
    private class GetDetails extends AsyncTask<Void, Void, Void> {


        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            if(counter==0) {


                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        bar.setVisibility(View.VISIBLE);
                    }
                });
            }

        }

        @Override
        protected Void doInBackground(Void... arg0) {
            HttpHandler sh = new HttpHandler();
            // Making a request to url and getting response
            String url = "http://10.130.150.223:5000/lab/"+lab+"/"+pc+"/cpu_stat";
            String jsonStr = sh.makeServiceCall(url);

            //Log.e(TAG, "Response from url: " + jsonStr);
            if (jsonStr != null) {
                try {
                    JSONObject jsonObj = new JSONObject(jsonStr);

                    Iterator<String> iter = jsonObj.keys();
                    while (iter.hasNext()) {
                        String key = iter.next();
                        try {
                            Double value = (Double) jsonObj.get(key);
                            status.put(key,value);
                        } catch (JSONException e) {
                            // Something went wrong!
                        }
                    }


                } catch (final JSONException e) {
                    Log.e(TAG, "Json parsing error: " + e.getMessage());

                }

            } else {
                Log.e(TAG, "Couldn't get json from server.");

            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            /*ListAdapter adapter = new SimpleAdapter(MainActivity.this, contactList,
                    R.layout.list_item, new String[]{ "email","mobile"},
                    new int[]{R.id.email, R.id.mobile});
            lv.setAdapter(adapter);*/
            try {
                String label;
                Integer no;
                Double util;
                String temp;
                Double temp_cpu_util=status.get("cpu");
                String temp_cpu_String=String.format("%3.2f",temp_cpu_util) + "%";
                cpu+=temp_cpu_String;
                for(int i=1;i<status.size();i++){
                   if(i%2==0)
                   {
                       String temp1="cpu"+(i-1);
                       util=status.get(temp1);
                       temp=String.format("Core %d: %.2f\n",i,util);
                       core+=temp;

                   }else{
                       String temp1="cpu"+(i-1);
                       util=status.get(temp1);
                       temp=String.format("Core %d: %-20.2f",i,util);
                       core+=temp;
                   }

                }
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        cpu_tv.setText(cpu);
                        core_tv.setText(core);
                       if(counter==0) {

                            counter=1;

                           bar.setVisibility(View.GONE);
                       }

                    }
                });
                 cpu="CPU Utilization :";
                 core="";
            }
            catch(Exception e){
                Log.e(TAG,e.getMessage());
            }
        }
    }


    @Override
    public void onBackPressed() {
        super.onBackPressed();
        handler.removeCallbacksAndMessages(null);
    }

    private class GetHardwareDetails extends AsyncTask<Void, Void, Void> {


        @Override
        protected void onPreExecute() {
            super.onPreExecute();


        }

        @Override
        protected Void doInBackground(Void... arg0) {
            HttpHandler sh = new HttpHandler();
            // Making a request to url and getting response
            String url = "http://10.130.150.223:5000/lab/"+lab+"/"+pc+"/hardware";
            String jsonStr = sh.makeServiceCall(url);

            //Log.e(TAG, "Response from url: " + jsonStr);
            if (jsonStr != null) {
                try {

                    JSONObject jsonObj = new JSONObject(jsonStr);
                    isKeyboardConnected=(Boolean)jsonObj.get("keyboard");
                    isMouseConnected=(Boolean)jsonObj.get("mouse");
/*                    while (iter.hasNext()) {
                        String key = iter.next();
                        try {
                            Double value = (Double) jsonObj.get(key);
                            status.put(key,value);
                        } catch (JSONException e) {
                            // Something went wrong!
                        }
                    }

*/
                } catch (final JSONException e) {
                    Log.e(TAG, "Json parsing error: " + e.getMessage());

                }

            } else {
                Log.e(TAG, "Couldn't get json from server.");

            }

            return null;
        }

        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            /*ListAdapter adapter = new SimpleAdapter(MainActivity.this, contactList,
                    R.layout.list_item, new String[]{ "email","mobile"},
                    new int[]{R.id.email, R.id.mobile});
            lv.setAdapter(adapter);*/
            try {

                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                     if(isKeyboardConnected==true){
                         fab_keyboard.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                     }
                     if(isMouseConnected==true){
                         fab_mouse.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(R.color.colorPrimaryDark)));
                     }
                        showFABMenu();
                    }
                });

            }
            catch(Exception e){
                Log.e(TAG,e.getMessage());
            }
        }
    }

}
